<?php
/*"******************************************************************************************************
*   (c) 2004-2006 by MulchProductions, www.mulchprod.de                                                 *
*   (c) 2007-2015 by Kajona, www.kajona.de                                                              *
*       Published under the GNU LGPL v2.1, see /system/licence_lgpl.txt                                 *
********************************************************************************************************/

/**
 * Interface for the admin-plugins of the stats-reports
 *
 * @package module_stats
 */
interface interface_admin_statsreports extends interface_generic_plugin {

    /**
     * Method used to fetch the report.
     * @return string
     */
    public function getReport();

    /**
     * Setter for the startdate of the interval
     *
     * @param int $intStartDate
     * @return void
     */
    public function setStartDate($intStartDate);

    /**
     * Setter for the enddate of the interval
     *
     * @param int $intEndDate
     * @return void
     */
    public function setEndDate($intEndDate);

    /**
     * Returns the url to a graph generated by the plugin.
     * If the reports generates more then one graph, an array of url can be returned
     * If the plugin can't create a graph, an empty string should be returned instead.
     *
     * @return string|array
     */
    public function getReportGraph();

    /**
     * This method returns, whether the report is able to report in intervals, or not.
     * If so, a interval-choose is added to the dateSelector
     * @return bool
     */
    public function isIntervalable();

    /**
     * Used to set the interval. Just to be used, if isIntervalable() returns true
     *
     * @param int $intInterval
     * @return void
     */
    public function setInterval($intInterval);

    /**
     * Returns the name / title of a report
     * @return string
     */
    public function getTitle();
}
